
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Import_issuesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const import_issues = await db.import_issues.create(
            {
                id: data.id || undefined,
        
        severity: data.severity
        ||
        null
            ,
            
        field_name: data.field_name
        ||
        null
            ,
            
        message: data.message
        ||
        null
            ,
            
        details: data.details
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await import_issues.setRow_result( data.row_result || null, {
            transaction,
        });
        
        await import_issues.setRule( data.rule || null, {
            transaction,
        });
        
        await import_issues.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return import_issues;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const import_issuesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                severity: item.severity
            ||
            null
            ,
            
                field_name: item.field_name
            ||
            null
            ,
            
                message: item.message
            ||
            null
            ,
            
                details: item.details
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const import_issues = await db.import_issues.bulkCreate(import_issuesData, { transaction });

        // For each item created, replace relation files
        

        return import_issues;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const import_issues = await db.import_issues.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.severity !== undefined) updatePayload.severity = data.severity;
        
        
        if (data.field_name !== undefined) updatePayload.field_name = data.field_name;
        
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.details !== undefined) updatePayload.details = data.details;
        
        
        updatePayload.updatedById = currentUser.id;

        await import_issues.update(updatePayload, {transaction});

        
        
        if (data.row_result !== undefined) {
            await import_issues.setRow_result(
              
              data.row_result,
              
              { transaction }
            );
        }
        
        if (data.rule !== undefined) {
            await import_issues.setRule(
              
              data.rule,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await import_issues.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return import_issues;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const import_issues = await db.import_issues.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of import_issues) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of import_issues) {
                await record.destroy({transaction});
            }
        });


        return import_issues;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const import_issues = await db.import_issues.findByPk(id, options);

        await import_issues.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await import_issues.destroy({
            transaction
        });

        return import_issues;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const import_issues = await db.import_issues.findOne(
            { where },
            { transaction },
        );

        if (!import_issues) {
            return import_issues;
        }

        const output = import_issues.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.row_result = await import_issues.getRow_result({
            transaction
        });
        
        
        output.rule = await import_issues.getRule({
            transaction
        });
        
        
        output.organizations = await import_issues.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.import_row_results,
        as: 'row_result',
        
        where: filter.row_result ? {
          [Op.or]: [
            { id: { [Op.in]: filter.row_result.split('|').map(term => Utils.uuid(term)) } },
            {
              primary_key_hint: {
                [Op.or]: filter.row_result.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.validation_rules,
        as: 'rule',
        
        where: filter.rule ? {
          [Op.or]: [
            { id: { [Op.in]: filter.rule.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.rule.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.field_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'import_issues',
                        'field_name',
                        filter.field_name,
                    ),
                };
            }
            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'import_issues',
                        'message',
                        filter.message,
                    ),
                };
            }
            
            if (filter.details) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'import_issues',
                        'details',
                        filter.details,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.severity) {
                where = {
                    ...where,
                severity: filter.severity,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.import_issues.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'import_issues',
                        'field_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.import_issues.findAll({
            attributes: [ 'id', 'field_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['field_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.field_name,
        }));
    }

    
};

